#include <amxmodx>

#define PLUGIN			"Menu Settings"
#define VERSION			"1.0"
#define AUTHOR			"EFFx"

#define MAX_PLAYERS		32

new const SoundReceive[] =	"misc/incaa.wav"
new const SoundSend[] =		"misc/sent.wav"

enum PlayerPrivateDatas
{
	bool:radio_on,
	bool:pmon, 
	bool:pmsound,
	gidPlayer
}

enum pCvarsSettings
{
	pCvarMotdVIP,
	pCvarMotdConcurses,
	pCvarMotdRules,
	pCvarMotdCommands,
	pCvarMotdBanList,
	pCvarMotdTeamSpeak,
	pCvarMotdPsychoStats
}

new pCvars[pCvarsSettings]

new gSayText

new PlayerPrivateData[MAX_PLAYERS+1][PlayerPrivateDatas]

public plugin_init() 
{
	register_plugin(PLUGIN, VERSION, AUTHOR)

	gSayText = get_user_msgid("SayText")

	register_dictionary("furien_gamesites.txt")

	pCvars[pCvarMotdVIP] = register_cvar("amx_motd_vip_features", "Link/ConfigsDir here")
	pCvars[pCvarMotdConcurses] = register_cvar("amx_motd_concurses", "Link/ConfigsDir here")
	pCvars[pCvarMotdRules] = register_cvar("amx_motd_vip_rules", "Link/ConfigsDir here")
	pCvars[pCvarMotdCommands] = register_cvar("amx_motd_vip_commands", "Link/ConfigsDir here")
	pCvars[pCvarMotdBanList] = register_cvar("amx_motd_vip_banlist", "Link/ConfigsDir here")
	pCvars[pCvarMotdTeamSpeak] = register_cvar("amx_motd_vip_teamspeak", "Link/ConfigsDir here")
	pCvars[pCvarMotdPsychoStats] = register_cvar("amx_psychostats_link", "Link/ConfigsDir here")
	
	register_clcmd("say /menu", "ClCmd_menu")
	
	register_clcmd("radio1", "CmdBlock")
	register_clcmd("radio2", "CmdBlock")
	register_clcmd("radio3", "CmdBlock")
	
	register_clcmd("say /pm", "cmd_privatemessage")
	register_clcmd("say_team /pm", "cmd_privatemessage")
    
	register_clcmd("Private", "cmd_player");
}
public plugin_precache()
{
	precache_sound(SoundSend)
	precache_sound(SoundReceive)
}
public client_putinserver(id)
{
	if(is_user_bot(id))
		return
	
	PlayerPrivateData[id][radio_on] = true
	PlayerPrivateData[id][pmon] = true
	PlayerPrivateData[id][pmsound] = true
}
public ClCmd_menu(id)
{
	new menu = menu_create("Menu \w( \r/menu\w )", "clcmd_menu_handle")

	new formatText[50]

	formatex(formatText, charsmax(formatText), "%L", id, "MENU_VIP_FEATURES")
	menu_additem(menu, formatText)

	formatex(formatText, charsmax(formatText), "%L", id, "MENU_INFORMATIONS")
	menu_additem(menu, formatText)

	formatex(formatText, charsmax(formatText), "%L", id, "MENU_RADIO")
	menu_additem(menu, formatText)

	formatex(formatText, charsmax(formatText), "%L^n----------------", id, "MENU_PRIVATE_MSG")
	menu_additem(menu, formatText)

	formatex(formatText, charsmax(formatText), "%L", id, "MENU_SERVERS")
	menu_additem(menu, formatText)

	formatex(formatText, charsmax(formatText), "%L", id, "MENU_TEAMSPEAK")
	menu_additem(menu, formatText)


	menu_display(id, menu)
}
public clcmd_menu_handle(id, menu, item)
{
	switch(item)
	{
		case 0:
		{	
			new szMotd[100]
			get_pcvar_string(pCvars[pCvarMotdVIP], szMotd, charsmax(szMotd))

			show_motd(id, szMotd, "VIP FEATURES")
			ClCmd_menu(id)
		}
		case 1:
		{
			Menu_2(id)
		}
		case 2:
		{
			radio_menu(id)
		}
		case 3:
		{
			pm_menu(id)
		}
		case 4:
		{
			client_cmd(id,"say /server")
		}
		case 5:
		{
			new szMotd[100]
			get_pcvar_string(pCvars[pCvarMotdTeamSpeak], szMotd, charsmax(szMotd))

			show_motd(id, szMotd, "TeamSpeak")
			ClCmd_menu(id)
		}
	}
	client_cmd(id,"spk buttons/lightswitch2")
	menu_destroy(menu)
	return PLUGIN_HANDLED
}
public pm_menu(id)
{
	new formatMsg[100]

	formatex(formatMsg,charsmax(formatMsg), "%L \w( \r/pm\w )", id, "MENU_SEND_PM_TITTLE")
	new sztittle = menu_create(formatMsg,"cmd_pm_menu_handler")
	
	formatex(formatMsg, charsmax(formatMsg), "%L", id, "MENU_SEND_PM")
	menu_additem(sztittle, formatMsg)

	formatex(formatMsg, charsmax(formatMsg), "%L^n", id, "MENU_SEND_PM_SETTINGS")
	menu_additem(sztittle, formatMsg)

	formatex(formatMsg, charsmax(formatMsg), "%L", id, "MENU_BACK")
	menu_additem(sztittle, formatMsg)
	
	menu_display(id,sztittle)
}
public cmd_pm_menu_handler(id, menu, item)
{
	switch(item)
	{
		case 0: cmd_privatemessage(id)
		case 1: pm_config(id)
		case 2: 
		{
			ClCmd_menu(id)
			client_cmd(id,"spk buttons/lightswitch2")
		}
	}
	menu_destroy(menu)
	return PLUGIN_HANDLED
}
public pm_config(id)
{
	new menu_text[128]
	
	formatex(menu_text,charsmax(menu_text),"%L \w( \r/pm\w )", id, "MENU_SEND_PM_SETTINGS")
	new menu3 = menu_create(menu_text, "menupm_menu_handle")
	
	formatex(menu_text,charsmax(menu_text),"%L \y[%s%L\y]^n\d- %L", id, "MENU_SETTINGS_RECEIVE", PlayerPrivateData[id][pmon] ? "\w" : "\r", id, PlayerPrivateData[id][pmon] ? "MENU_ENABLED" : "MENU_DISABLED", id, "MENU_SETTINGS_RECEIVE_DESCRIP")
	menu_additem(menu3,menu_text);
	
	formatex(menu_text,charsmax(menu_text),"%L \y[%s%L\y]^n\d- %L", id, "MENU_SETTINGS_SOUND", PlayerPrivateData[id][pmsound] ? "\w" : "\r", id, PlayerPrivateData[id][pmsound] ? "MENU_ENABLED" : "MENU_DISABLED", id, "MENU_SETTINGS_SOUND_DESCRIP")
	menu_additem(menu3,menu_text);
	
	formatex(menu_text, charsmax(menu_text), "%L", id, "MENU_BACK")
	menu_additem(menu3, menu_text)
	
	menu_display(id, menu3)
	menu_setprop(menu3, MPROP_NUMBER_COLOR, "\r")
}
public menupm_menu_handle(id, menu, item)
{
	switch(item)
	{
		case 0:
		{
			switch(PlayerPrivateData[id][pmon])
			{
				case false:
				{
					PlayerPrivateData[id][pmon] = true
					ChatColor(id,"%L", id, "CHAT_SETTINGS_RECEIVE", id, "MENU_ENABLED")
					pm_config(id)
					client_cmd(id,"spk buttons/lightswitch2")
				}
				case true:
				{
					PlayerPrivateData[id][pmon] = false
					ChatColor(id,"%L", id, "CHAT_SETTINGS_RECEIVE",id, "MENU_DISABLED")
					pm_config(id)
					client_cmd(id,"spk buttons/lightswitch2")
				}
			}
		}
		case 1:
		{
			switch(PlayerPrivateData[id][pmsound])
			{
				case false:
				{
					PlayerPrivateData[id][pmsound] = true
					ChatColor(id,"%L", id, "CHAT_SETTINGS_SOUND", id, "MENU_ENABLED")
					pm_config(id)
					client_cmd(id,"spk buttons/lightswitch2")
				}
				case true:
				{
					PlayerPrivateData[id][pmsound] = false
					ChatColor(id,"%L", id, "CHAT_SETTINGS_SOUND", id, "MENU_DISABLED")
					pm_config(id)
					client_cmd(id,"spk buttons/lightswitch2")
				}
			}
		}
		case 2:
		{
			pm_menu(id)
			client_cmd(id,"spk buttons/lightswitch2")
		}
	}
	menu_destroy(menu)
	return PLUGIN_HANDLED
}
public Menu_2(id)
{
	new menu2 = menu_create("Menu \w( \r/menu\w )", "menu2_menu_handle")

	new formatText[20]
	formatex(formatText,charsmax(formatText), "%L", id, "MENU_INFORMATIONS_STATISTICS")
	menu_additem(menu2, formatText)

	formatex(formatText,charsmax(formatText), "%L", id, "MENU_INFORMATIONS_CONCURSES")
	menu_additem(menu2, formatText)

	formatex(formatText,charsmax(formatText), "%L", id, "MENU_INFORMATIONS_RULES")
	menu_additem(menu2, formatText)

	formatex(formatText,charsmax(formatText), "%L", id, "MENU_INFORMATIONS_COMMANDS")
	menu_additem(menu2, formatText)

	formatex(formatText,charsmax(formatText), "%L", id, "MENU_INFORMATIONS_ADMINS")
	menu_additem(menu2, formatText)

	formatex(formatText,charsmax(formatText), "\r%L^n", id, "MENU_INFORMATIONS_BANLIST")
	menu_additem(menu2, formatText)

	formatex(formatText,charsmax(formatText), "%L", id, "MENU_BACK")
	menu_additem(menu2, formatText)
	
	menu_display(id, menu2)
}
public menu2_menu_handle(id, menu, item)
{
	switch(item)
	{
		case 0:
		{
			Estatisticas(id)
			client_cmd(id,"spk buttons/lightswitch2")
		}
		case 1:
		{
			Menu_2(id)
			client_cmd(id,"spk buttons/lightswitch2")

			new szMotd[100]
			get_pcvar_string(pCvars[pCvarMotdConcurses], szMotd, charsmax(szMotd))

			show_motd(id,szMotd, "Concurses")
		}
		case 2:
		{
			new szMotd[100]
			get_pcvar_string(pCvars[pCvarMotdRules], szMotd, charsmax(szMotd))

			show_motd(id, szMotd, "Rules")
			Menu_2(id)
			client_cmd(id,"spk buttons/lightswitch2")
		}
		case 3:
		{
			new szMotd[100]
			get_pcvar_string(pCvars[pCvarMotdCommands], szMotd, charsmax(szMotd))

			show_motd(id, szMotd, "Commands")

			Menu_2(id)
			client_cmd(id,"spk buttons/lightswitch2")
		}
		case 4:
		{
			client_cmd(id,"say /admin")
			Menu_2(id)
			client_cmd(id,"spk buttons/lightswitch2")
		}
		case 5:
		{
			new szMotd[100]
			get_pcvar_string(pCvars[pCvarMotdBanList], szMotd, charsmax(szMotd))

			show_motd(id,szMotd,"Banlist")
			Menu_2(id)
			client_cmd(id,"spk buttons/lightswitch2")
		}
		case 6:
		{
			ClCmd_menu(id)
			client_cmd(id,"spk buttons/lightswitch2")
		}
	}
	menu_destroy(menu)
	return PLUGIN_HANDLED
}
public radio_menu(id)
{
	new menu_text[128]
	new menu3 = menu_create("Menu \w( \r/menu\w )", "menu4_menu_handle")
	
	formatex(menu_text,charsmax(menu_text),"%L \y[%s%L\y]^n\d- %L", id, "MENU_RADIO", PlayerPrivateData[id][radio_on] ? "\w" : "\r", id, PlayerPrivateData[id][radio_on] ? "MENU_ENABLED" : "MENU_DISABLED", id, "MENU_RADIO_DESCRIP")
	menu_additem(menu3,menu_text);
	
	formatex(menu_text, charsmax(menu_text), "%L", id, "MENU_BACK")
	menu_additem(menu3, menu_text)
	
	menu_display(id, menu3)
	menu_setprop(menu3, MPROP_NUMBER_COLOR, "\r")
}
public menu4_menu_handle(id, menu, item)
{
	switch(item)
	{
		case 0:
		{
			switch(PlayerPrivateData[id][radio_on])
			{
				case false:
				{
					PlayerPrivateData[id][radio_on] = true
					radio_menu(id)
					client_cmd(id,"spk buttons/lightswitch2")
				}
				case true:
				{
					PlayerPrivateData[id][radio_on] = false
					radio_menu(id)
					client_cmd(id,"spk buttons/lightswitch2")
				}
			}
		}
		case 1:
		{
			ClCmd_menu(id)
			client_cmd(id,"spk buttons/lightswitch2")
		}
	}
	menu_destroy(menu)
	return PLUGIN_HANDLED
}
public CmdBlock(id) 
{
	if(!PlayerPrivateData[id][radio_on])
		return PLUGIN_HANDLED

	return PLUGIN_CONTINUE
}
public Estatisticas(id)
{
	new menu3 = menu_create("Menu \w( \r/menu\w )", "menu3_menu_handle")

	new formatMenu[128]

	formatex(formatMenu, charsmax(formatMenu), "\yTOP15^n\d-%L", id, "MENU_INFOS_TOP15")
	menu_additem(menu3,formatMenu)

	formatex(formatMenu, charsmax(formatMenu), "Rank^n\d-%L", id, "MENU_INFOS_RAN")
	menu_additem(menu3,formatMenu)

	formatex(formatMenu, charsmax(formatMenu), "StatsMe^n\d-%L", id, "MENU_INFOS_STATSME")
	menu_additem(menu3,formatMenu)

	formatex(formatMenu, charsmax(formatMenu), "Stats^n\d-%L", id, "MENU_INFOS_STATS")
	menu_additem(menu3,formatMenu)

	formatex(formatMenu, charsmax(formatMenu), "PsychoStats^n\d-%L", id, "MENU_INFOS_PSYCHOSTATS")
	menu_additem(menu3,formatMenu)
	
	new formatMsg[100]
	formatex(formatMsg, charsmax(formatMsg), "%L", id, "MENU_BACK")
	menu_additem(menu3, formatMsg)
	
	menu_display(id, menu3)
}
public menu3_menu_handle(id, menu, item)
{
	switch(item)
	{
		case 0:
		{
			client_cmd(id,"say /top15")
			Estatisticas(id)
			client_cmd(id,"spk buttons/lightswitch2")
		}
		case 1:
		{
			client_cmd(id,"say /rank")
			Estatisticas(id)
			client_cmd(id,"spk buttons/lightswitch2")
		}
		case 2:
		{
			client_cmd(id,"say /statsme")
			Estatisticas(id)
			client_cmd(id,"spk buttons/lightswitch2")
		}
		case 3:
		{
			client_cmd(id,"say /stats")
			Estatisticas(id)
			client_cmd(id,"spk buttons/lightswitch2")
		}
		case 4:
		{
			new szMotd[100]
			get_pcvar_string(pCvars[pCvarMotdPsychoStats], szMotd, charsmax(szMotd))

			show_motd(id,szMotd, "PsychoStats")

			Estatisticas(id)
			client_cmd(id,"spk buttons/lightswitch2")
		}
		case 5:
		{
			ClCmd_menu(id)
			client_cmd(id,"spk buttons/lightswitch2")
		}
	}
	menu_destroy(menu)
	return PLUGIN_HANDLED
}
public cmd_privatemessage(id)
{
	new formatMsg[25]
	formatex(formatMsg, charsmax(formatMsg), "%L \w(\r /pm \w)", id, "MENU_SEND_PM")
	new iMenu = menu_create(formatMsg,"cmd_pm")
	
	static opcion[64]
	new players[32], pnum, tempid
	new szName[32], szTempid[10]
    
	get_players(players, pnum, "h")
    
	for( new i;i < pnum; i++)
	{
		tempid = players[i]
        
		get_user_name(tempid, szName, charsmax(szName))
		num_to_str(tempid, szTempid, charsmax(szTempid))
		
		formatex(opcion, charsmax(opcion), "\w%s", szName)
		menu_additem(iMenu, opcion, szTempid, 0)
	}
	menu_display(id, iMenu)
	return PLUGIN_HANDLED
}

public cmd_pm(id, menu, item)
{
	new Data[6], Name[64]
	new Access, Callback
	menu_item_getinfo(menu, item, Access, Data, charsmax(Data), Name, charsmax(Name), Callback)
    
	new tempid = str_to_num(Data)
    
	PlayerPrivateData[id][gidPlayer] = tempid
	client_cmd(id, "messagemode Private")
    
	menu_destroy(menu)
	return PLUGIN_HANDLED
}

public cmd_player(id)
{
 	new say[300]
	read_args(say, charsmax(say))
    
	remove_quotes(say)
    
	if(equal(say, ""))
		return PLUGIN_HANDLED 
    
	cmd_send_pm(id, say)   
	return PLUGIN_CONTINUE
}

public cmd_send_pm(id, say[])
{
	new player = PlayerPrivateData[id][gidPlayer]
    
	printMessage(player, id, say)
	return PLUGIN_HANDLED
}

printMessage(reciever, sender, const message[])
{
	new szSenderName[32], szRecieverName[32]
	get_user_name(sender, szSenderName, charsmax(szSenderName))
	get_user_name(reciever, szRecieverName, charsmax(szRecieverName))

	if(PlayerPrivateData[reciever][pmon])
	{
		if(PlayerPrivateData[sender][pmsound])
			client_cmd(sender,"spk ^"%s^"", SoundSend)
			
		if(PlayerPrivateData[reciever][pmsound])
			client_cmd(reciever,"spk ^"%s^"", SoundReceive)
			
		ChatColor(sender,"!g[!yPrivate!g]!y %L", sender, "PLAYER_HAS_SEND", szRecieverName, message)

		new szAccess[9]
		switch(get_user_flags(sender))
		{
			case ADMIN_LEVEL_G:
				formatex(szAccess, charsmax(szAccess), "!gEVIP")

			case ADMIN_LEVEL_H:
				formatex(szAccess, charsmax(szAccess), "!tVIP")

			case ADMIN_IMMUNITY:
				formatex(szAccess, charsmax(szAccess), "!gADMIN")

			default:
				formatex(szAccess, charsmax(szAccess), "!yPlayer")
		}
		ChatColor(reciever,"!g[!yPrivate!g] %s!t %s!y %L:!t %s", szAccess, szSenderName, reciever, "PLAYER_HAS_SEND_TO_YOU", message)
	}
	else
	{
		ChatColor(reciever,"!g[!yPrivate!g] !t%s!y %L", szRecieverName, sender, "PLAYER_WANTNOT_PM")
	}
	return PLUGIN_HANDLED
}

stock ChatColor(const id, const szMessage[], any:...) 
{
	new iCount = 1, iPlayers[32], Player

	static szMsg[191]
	vformat(szMsg, charsmax(szMsg), szMessage, 3)

	replace_all(szMsg, charsmax(szMsg), "!g", "^4")
	replace_all(szMsg, charsmax(szMsg), "!y", "^1")
	replace_all(szMsg, charsmax(szMsg), "!t", "^3")
	
	if(id) iPlayers[0] = id; else get_players(iPlayers, iCount, "ch")
	{
		for(new i = 0; i < iCount; i++)
		{
			Player = iPlayers[i]

			message_begin(MSG_ONE_UNRELIABLE, gSayText, .player = Player )  
			write_byte(Player)
			write_string(szMsg)
			message_end()
		}
	}
}
